(function ($) {
  Drupal.behaviors.datatables = {
    attach: function (context, settings) {
      $.each(settings.datatables, function (selector) {
        $(selector, context).once('datatables', function() {
          // Check if table contains expandable hidden rows.
          var settings = Drupal.settings.datatables[selector];
          if (settings.bExpandable) {
            // Insert a "view more" column to the table.
            var nCloneTh = document.createElement('th');
            var nCloneTd = document.createElement('td');
            nCloneTd.innerHTML = '<a href="#" class="datatables-expand datatables-closed">Show Implications</a>';
			
			var isIE7 = (navigator.appVersion.indexOf('MSIE 7') >= 0);
			var isIE8 = (navigator.appVersion.indexOf('MSIE 8') >= 0);
			var isOldIE = (isIE7 || isIE8);

            $(selector + ' thead tr').each( function () {
              if (isOldIE) this.insertBefore( nCloneTh, this.childNodes[this.childNodes.length-1] );
              else this.insertBefore( nCloneTh, this.childNodes[this.childNodes.length-2] );
            });

            $(selector + ' tbody tr').each( function () {
              if (isOldIE) this.insertBefore(  nCloneTd.cloneNode( true ), this.childNodes[this.childNodes.length-1] );
              else this.insertBefore(  nCloneTd.cloneNode( true ), this.childNodes[this.childNodes.length-2] );
            });
			
            settings.aoColumns.unshift({sType:"html","bSortable": false});
            $(settings.aoColumns).each( function () {
				this["bSortable"] = true;
				this["sType"] = "html";
			});
          }
		  settings["aaSorting"] = [[0,"asc"]];
		  //alert(settings.toSource());

          var datatable = $(selector).dataTable(settings);

          if (settings.bExpandable) {
            // Add column headers to table settings.
            var datatables_settings = datatable.fnSettings();
            // Add blank column header for show Implications column.
            settings.aoColumnHeaders.unshift('');
            // Add column headers to table settings.
            datatables_settings.aoColumnHeaders = settings.aoColumnHeaders;

            /* Add event listener for opening and closing Implications
            * Note that the indicator for showing which row is open is not controlled by DataTables,
            * rather it is done here
            */
            $('td a.datatables-expand', datatable.fnGetNodes() ).each( function () {
              $(this).click( function () {
                var row = this.parentNode.parentNode;
                if (datatable.fnIsOpen(row)) {
                  datatable.fnClose(row);
                  $(this).html('Show Implications');
                }
                else {
                  datatable.fnOpen( row, Drupal.theme('datatablesExpandableRow', datatable, row), 'Implications' );
                  $(this).html('Hide Implications');
                }
                return false;
              });
            });
          }
        });
      });
    }
  };

  /**
  * Theme an expandable hidden row.
  *
  * @param object
  *   The datatable object.
  * @param array
  *   The row array for which the hidden row is being displayed.
  * @return
  *   The formatted text (html).
  */
  Drupal.theme.prototype.datatablesExpandableRow = function(datatable, row) {
    var rowData = datatable.fnGetData(row);
    var settings = datatable.fnSettings();

    var output = '<table style="padding-left: 50px">';
    $.each(rowData, function(index) {
      if (!settings.aoColumns[index].bVisible) {
        output += '<tr><td>' + settings.aoColumnHeaders[index] + '</td><td style="text-align: left">' + this + '</td></tr>';
      }
    });
    output += '</table>';
    return output;
  };
})(jQuery);
